unit Uperios;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, ExtCtrls, StdCtrls;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    SBExit: TSpeedButton;
    Label1: TLabel;
    procedure SBExitClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

uses
  math1, CData, udetails;

const
  xDist = 27;
  yDist = 22;
  xShift = 5;
  yShift = 4;
  xAngle = 30;
  yAngle = 70;


(***************************************************************)
procedure TForm2.SBExitClick(Sender: TObject);
(***************************************************************)

begin
close;
end;


(***************************************************************)
procedure TForm2.FormPaint(Sender: TObject);
(***************************************************************)

var
  i   : integer;
  x,y : integer;

begin
Canvas.Brush.Color := clWhite;
Canvas.Font.Color := clNavy;
for i:=1 to MaxChemElem do
  begin
  PersysCoord (i,x,y);
  Canvas.TextOut (xAngle+xDist*x,yAngle+yDist*y,CElemSymb(i));
  Canvas.MoveTo (xAngle+xDist*x-XShift,yAngle+yDist*y-yShift);
  Canvas.LineTo (xAngle+xDist*(x+1)-XShift,yAngle+yDist*y-yShift);
  Canvas.LineTo (xAngle+xDist*(x+1)-XShift,yAngle+yDist*(y+1)-yShift);
  Canvas.LineTo (xAngle+xDist*x-XShift,yAngle+yDist*(y+1)-yShift);
  Canvas.LineTo (xAngle+xDist*x-XShift,yAngle+yDist*y-yShift);
  end;
end;

(***************************************************************)
procedure TForm2.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
(***************************************************************)

var
  i     : integer;
  ex,ey : integer;

begin
x := (x - XAngle+XShift) div xDist;
y := (y - YAngle+YShift) div ydist;
for i:=1 to MaxChemElem do
  begin
  PersysCoord (i,ex,ey);
  if (x = ex) and (y = ey) then
    begin
    Canvas.Brush.Color := clBlue;
    Canvas.Font.Color := clWhite;
    Canvas.TextOut (xAngle+xDist*x,yAngle+yDist*y,CElemSymb(i));
    Canvas.Brush.Color := clWhite;
    Canvas.Font.Color := clNavy;
    FormDetails.LblAtNum.Caption := IntToStr(i);
    FormDetails.LblName.Caption := CElemName(i);
    FormDetails.LblSymb.Caption := CElemSymb(i);
    FormDetails.LblExactMass.Caption := strf(ExactAtWeight(i),1,6);
    FormDetails.LblAvgMass.Caption := strf(ChemAtWeight(i),1,6);
    FormDetails.LblIntMass.Caption := strf(IntAtWeight(i),1,0);
    FormDetails.Left := x*XDist+left;
    FormDetails.Top := 110+y*YDist+Top;
    FormDetails.ShowModal;
    Canvas.TextOut (xAngle+xDist*x,yAngle+yDist*y,CElemSymb(i));
    end;
  end;
end;
end.


